diff --git a/extensions/labs/src/views/servicePluginsView.ts b/extensions/labs/src/views/servicePluginsView.ts
index 38f09f80..cd7214db 100644
--- a/extensions/labs/src/views/servicePluginsView.ts
+++ b/extensions/labs/src/views/servicePluginsView.ts
@@ -29,6 +29,12 @@ export function activate(context: vscode.ExtensionContext) {
 				const items: ServicePluginItem[] = [];
 				for (const extension of extensions) {
 					for (const client of extension.exports.volarLabs.languageClients) {
+						if (
+							!client.clientOptions.documentSelector
+							|| !vscode.languages.match(client.clientOptions.documentSelector, doc)
+						) {
+							continue;
+						}
 						const servicePlugins = await client.sendRequest(extension.exports.volarLabs.languageServerProtocol.GetServicePluginsRequest.type, { uri: doc.uri.toString() });
 						if (servicePlugins) {
 							for (const servicePlugin of servicePlugins) {
diff --git a/extensions/labs/src/views/virtualFilesView.ts b/extensions/labs/src/views/virtualFilesView.ts
index 861a3f02..549e602d 100644
--- a/extensions/labs/src/views/virtualFilesView.ts
+++ b/extensions/labs/src/views/virtualFilesView.ts
@@ -51,6 +51,12 @@ export async function activate(context: vscode.ExtensionContext) {
 				const items: VirtualFileItem[] = [];
 				for (const extension of extensions) {
 					for (const client of extension.exports.volarLabs.languageClients) {
+						if (
+							!client.clientOptions.documentSelector
+							|| !vscode.languages.match(client.clientOptions.documentSelector, currentDocument)
+						) {
+							continue;
+						}
 						const virtualFile = await client.sendRequest(
 							extension.exports.volarLabs.languageServerProtocol.GetVirtualFileRequest.type,
 							{
diff --git a/packages/language-core/index.ts b/packages/language-core/index.ts
index cefcd2e7..d8447191 100644
--- a/packages/language-core/index.ts
+++ b/packages/language-core/index.ts
@@ -1,5 +1,5 @@
 export { Mapping, SourceMap } from '@volar/source-map';
-export * from './lib/editorFeatures';
+export * from './lib/editor';
 export * from './lib/linkedCodeMap';
 export * from './lib/types';
 export * from './lib/utils';
diff --git a/packages/language-core/lib/editorFeatures.ts b/packages/language-core/lib/editor.ts
similarity index 62%
rename from packages/language-core/lib/editorFeatures.ts
rename to packages/language-core/lib/editor.ts
index 46bc056c..c9d75877 100644
--- a/packages/language-core/lib/editorFeatures.ts
+++ b/packages/language-core/lib/editor.ts
@@ -1,4 +1,4 @@
-import type { CodeInformation } from './types';
+import type { CodeInformation, Mapper } from './types';
 
 export function isHoverEnabled(info: CodeInformation): boolean {
 	return !!info.semantic;
@@ -129,3 +129,71 @@ export function resolveRenameEditText(text: string, info: CodeInformation): stri
 		? info.navigation.resolveRenameEditText?.(text) ?? text
 		: text;
 }
+
+export function findOverlapCodeRange(
+	start: number,
+	end: number,
+	map: Mapper,
+	filter: (data: CodeInformation) => boolean
+) {
+	let mappedStart: number | undefined;
+	let mappedEnd: number | undefined;
+
+	for (const [mapped, mapping] of map.toGeneratedLocation(start)) {
+		if (filter(mapping.data)) {
+			mappedStart = mapped;
+			break;
+		}
+	}
+	for (const [mapped, mapping] of map.toGeneratedLocation(end)) {
+		if (filter(mapping.data)) {
+			mappedEnd = mapped;
+			break;
+		}
+	}
+
+	if (mappedStart === undefined || mappedEnd === undefined) {
+		for (const mapping of map.mappings) {
+			if (filter(mapping.data)) {
+				const mappingStart = mapping.sourceOffsets[0];
+				const mappingEnd = mapping.sourceOffsets[mapping.sourceOffsets.length - 1] + mapping.lengths[mapping.lengths.length - 1];
+				const overlap = getOverlapRange(start, end, mappingStart, mappingEnd);
+				if (overlap) {
+					const curMappedStart = (overlap.start - mappingStart) + mapping.generatedOffsets[0];
+					const lastGeneratedLength = (mapping.generatedLengths ?? mapping.lengths)[mapping.generatedOffsets.length - 1];
+					const curMappedEndOffset = Math.min(overlap.end - mapping.sourceOffsets[mapping.sourceOffsets.length - 1], lastGeneratedLength);
+					const curMappedEnd = mapping.generatedOffsets[mapping.generatedOffsets.length - 1] + curMappedEndOffset;
+
+					mappedStart = mappedStart === undefined ? curMappedStart : Math.min(mappedStart, curMappedStart);
+					mappedEnd = mappedEnd === undefined ? curMappedEnd : Math.max(mappedEnd, curMappedEnd);
+				}
+			}
+		}
+	}
+
+	if (mappedStart !== undefined && mappedEnd !== undefined) {
+		return {
+			start: mappedStart,
+			end: mappedEnd,
+		};
+	}
+}
+
+function getOverlapRange(
+	range1Start: number,
+	range1End: number,
+	range2Start: number,
+	range2End: number
+): { start: number, end: number; } | undefined {
+	const start = Math.max(range1Start, range2Start);
+	const end = Math.min(range1End, range2End);
+
+	if (start > end) {
+		return undefined;
+	}
+
+	return {
+		start,
+		end,
+	};
+}
diff --git a/packages/language-service/tests/findOverlapCodeRange.spec.ts b/packages/language-core/tests/findOverlapCodeRange.spec.ts
similarity index 94%
rename from packages/language-service/tests/findOverlapCodeRange.spec.ts
rename to packages/language-core/tests/findOverlapCodeRange.spec.ts
index 402f1266..c91aea45 100644
--- a/packages/language-service/tests/findOverlapCodeRange.spec.ts
+++ b/packages/language-core/tests/findOverlapCodeRange.spec.ts
@@ -1,6 +1,5 @@
 import { describe, expect, it } from 'vitest';
-import { findOverlapCodeRange } from '../lib/utils/common';
-import { CodeInformation, Mapping, defaultMapperFactory } from '@volar/language-core';
+import { CodeInformation, Mapping, defaultMapperFactory, findOverlapCodeRange } from '../index';
 
 // test code: <html><body><p>Hello</p></body></html>
 
diff --git a/packages/language-service/lib/features/provideCodeActions.ts b/packages/language-service/lib/features/provideCodeActions.ts
index e79db79e..649eaa36 100644
--- a/packages/language-service/lib/features/provideCodeActions.ts
+++ b/packages/language-service/lib/features/provideCodeActions.ts
@@ -1,9 +1,8 @@
-import { isCodeActionsEnabled } from '@volar/language-core';
+import { findOverlapCodeRange, isCodeActionsEnabled } from '@volar/language-core';
 import type * as vscode from 'vscode-languageserver-protocol';
 import { URI } from 'vscode-uri';
 import type { LanguageServiceContext } from '../types';
 import { NoneCancellationToken } from '../utils/cancellation';
-import { findOverlapCodeRange } from '../utils/common';
 import * as dedupe from '../utils/dedupe';
 import { getGeneratedRange, languageFeatureWorker } from '../utils/featureWorkers';
 import { transformLocations, transformWorkspaceEdit } from '../utils/transform';
diff --git a/packages/language-service/lib/features/provideDocumentFormattingEdits.ts b/packages/language-service/lib/features/provideDocumentFormattingEdits.ts
index ac71c1a3..59876a32 100644
--- a/packages/language-service/lib/features/provideDocumentFormattingEdits.ts
+++ b/packages/language-service/lib/features/provideDocumentFormattingEdits.ts
@@ -1,10 +1,10 @@
-import { SourceScript, VirtualCode, forEachEmbeddedCode, isFormattingEnabled } from '@volar/language-core';
+import { SourceScript, VirtualCode, findOverlapCodeRange, forEachEmbeddedCode, isFormattingEnabled } from '@volar/language-core';
 import type * as vscode from 'vscode-languageserver-protocol';
 import { TextDocument } from 'vscode-languageserver-textdocument';
 import { URI } from 'vscode-uri';
 import type { EmbeddedCodeFormattingOptions, LanguageServiceContext } from '../types';
 import { NoneCancellationToken } from '../utils/cancellation';
-import { findOverlapCodeRange, stringToSnapshot } from '../utils/common';
+import { stringToSnapshot } from '../utils/common';
 import { DocumentsAndMap, getGeneratedPositions, getSourceRange } from '../utils/featureWorkers';
 
 export function register(context: LanguageServiceContext) {
diff --git a/packages/language-service/lib/features/provideDocumentSemanticTokens.ts b/packages/language-service/lib/features/provideDocumentSemanticTokens.ts
index 870234bc..ee9450c8 100644
--- a/packages/language-service/lib/features/provideDocumentSemanticTokens.ts
+++ b/packages/language-service/lib/features/provideDocumentSemanticTokens.ts
@@ -1,10 +1,9 @@
-import { isSemanticTokensEnabled } from '@volar/language-core';
+import { findOverlapCodeRange, isSemanticTokensEnabled } from '@volar/language-core';
 import type * as vscode from 'vscode-languageserver-protocol';
 import { URI } from 'vscode-uri';
 import type { LanguageServiceContext, SemanticToken } from '../types';
 import { SemanticTokensBuilder } from '../utils/SemanticTokensBuilder';
 import { NoneCancellationToken } from '../utils/cancellation';
-import { findOverlapCodeRange } from '../utils/common';
 import { getSourceRange, languageFeatureWorker } from '../utils/featureWorkers';
 
 export function register(context: LanguageServiceContext) {
diff --git a/packages/language-service/lib/features/provideInlayHints.ts b/packages/language-service/lib/features/provideInlayHints.ts
index 835f6f22..d5698347 100644
--- a/packages/language-service/lib/features/provideInlayHints.ts
+++ b/packages/language-service/lib/features/provideInlayHints.ts
@@ -1,9 +1,8 @@
-import { isInlayHintsEnabled } from '@volar/language-core';
+import { findOverlapCodeRange, isInlayHintsEnabled } from '@volar/language-core';
 import type * as vscode from 'vscode-languageserver-protocol';
 import { URI } from 'vscode-uri';
 import type { LanguageServiceContext } from '../types';
 import { NoneCancellationToken } from '../utils/cancellation';
-import { findOverlapCodeRange } from '../utils/common';
 import { getSourcePositions, getSourceRange, languageFeatureWorker } from '../utils/featureWorkers';
 import { transformTextEdit } from '../utils/transform';
 
diff --git a/packages/language-service/lib/utils/common.ts b/packages/language-service/lib/utils/common.ts
index b01e3c7a..5ff59b9e 100644
--- a/packages/language-service/lib/utils/common.ts
+++ b/packages/language-service/lib/utils/common.ts
@@ -1,76 +1,6 @@
-import type { CodeInformation, Mapper } from '@volar/language-core';
 import type * as ts from 'typescript';
 import type * as vscode from 'vscode-languageserver-protocol';
 
-export function findOverlapCodeRange(
-	start: number,
-	end: number,
-	map: Mapper,
-	filter: (data: CodeInformation) => boolean
-) {
-	let mappedStart: number | undefined;
-	let mappedEnd: number | undefined;
-
-	for (const [mapped, mapping] of map.toGeneratedLocation(start)) {
-		if (filter(mapping.data)) {
-			mappedStart = mapped;
-			break;
-		}
-	}
-	for (const [mapped, mapping] of map.toGeneratedLocation(end)) {
-		if (filter(mapping.data)) {
-			mappedEnd = mapped;
-			break;
-		}
-	}
-
-	if (mappedStart === undefined || mappedEnd === undefined) {
-		for (const mapping of map.mappings) {
-			if (filter(mapping.data)) {
-				const mappingStart = mapping.sourceOffsets[0];
-				const mappingEnd = mapping.sourceOffsets[mapping.sourceOffsets.length - 1] + mapping.lengths[mapping.lengths.length - 1];
-				const overlap = getOverlapRange(start, end, mappingStart, mappingEnd);
-				if (overlap) {
-					const curMappedStart = (overlap.start - mappingStart) + mapping.generatedOffsets[0];
-					const lastGeneratedLength = (mapping.generatedLengths ?? mapping.lengths)[mapping.generatedOffsets.length - 1];
-					const curMappedEndOffset = Math.min(overlap.end - mapping.sourceOffsets[mapping.sourceOffsets.length - 1], lastGeneratedLength);
-					const curMappedEnd = mapping.generatedOffsets[mapping.generatedOffsets.length - 1] + curMappedEndOffset;
-
-					mappedStart = mappedStart === undefined ? curMappedStart : Math.min(mappedStart, curMappedStart);
-					mappedEnd = mappedEnd === undefined ? curMappedEnd : Math.max(mappedEnd, curMappedEnd);
-				}
-			}
-		}
-	}
-
-	if (mappedStart !== undefined && mappedEnd !== undefined) {
-		return {
-			start: mappedStart,
-			end: mappedEnd,
-		};
-	}
-}
-
-function getOverlapRange(
-	range1Start: number,
-	range1End: number,
-	range2Start: number,
-	range2End: number
-): { start: number, end: number; } | undefined {
-
-	const start = Math.max(range1Start, range2Start);
-	const end = Math.min(range1End, range2End);
-
-	if (start > end) {
-		return undefined;
-	}
-
-	return {
-		start,
-		end,
-	};
-}
-
 export function isInsideRange(parent: vscode.Range, child: vscode.Range) {
 	if (child.start.line < parent.start.line) {
 		return false;
diff --git a/packages/typescript/lib/node/proxyCreateProgram.ts b/packages/typescript/lib/node/proxyCreateProgram.ts
index a4e0a0fc..dd8f8677 100644
--- a/packages/typescript/lib/node/proxyCreateProgram.ts
+++ b/packages/typescript/lib/node/proxyCreateProgram.ts
@@ -221,9 +221,6 @@ export function proxyCreateProgram(
 
 			decorateProgram(language, program);
 
-			// TODO: #128
-			(program as any).__volar__ = { language };
-
 			return program;
 		},
 	});
diff --git a/packages/typescript/lib/node/proxyLanguageService.ts b/packages/typescript/lib/node/proxyLanguageService.ts
index ad767414..d24d00cf 100644
--- a/packages/typescript/lib/node/proxyLanguageService.ts
+++ b/packages/typescript/lib/node/proxyLanguageService.ts
@@ -1,6 +1,6 @@
 import {
 	CodeInformation,
-	Language,
+	findOverlapCodeRange,
 	isCallHierarchyEnabled,
 	isCodeActionsEnabled,
 	isCompletionEnabled,
@@ -16,6 +16,7 @@ import {
 	isSemanticTokensEnabled,
 	isSignatureHelpEnabled,
 	isTypeDefinitionEnabled,
+	Language,
 } from '@volar/language-core';
 import type * as ts from 'typescript';
 import { dedupeDocumentSpans } from './dedupe';
@@ -23,6 +24,7 @@ import {
 	getMappingOffset,
 	toGeneratedOffset,
 	toGeneratedOffsets,
+	toGeneratedRange,
 	toGeneratedRanges,
 	toSourceOffset,
 	toSourceRanges,
@@ -177,10 +179,9 @@ function getFormattingEditsForRange(language: Language<string>, getFormattingEdi
 			return [];
 		}
 		if (serviceScript) {
-			const generateStart = toGeneratedOffset(language, serviceScript, sourceScript, start, isFormattingEnabled);
-			const generateEnd = toGeneratedOffset(language, serviceScript, sourceScript, end, isFormattingEnabled);
-			if (generateStart !== undefined && generateEnd !== undefined) {
-				const edits = getFormattingEditsForRange(targetScript.id, generateStart, generateEnd, options);
+			const generatedRange = toGeneratedRange(language, serviceScript, sourceScript, start, end, isFormattingEnabled);
+			if (generatedRange !== undefined) {
+				const edits = getFormattingEditsForRange(targetScript.id, generatedRange[0], generatedRange[1], options);
 				return edits
 					.map(edit => transformTextChange(sourceScript, language, serviceScript, edit, false, isFormattingEnabled)?.[1])
 					.filter(edit => !!edit);
@@ -580,13 +581,12 @@ function getCodeFixesAtPosition(language: Language<string>, getCodeFixesAtPositi
 			return [];
 		}
 		if (serviceScript) {
-			const generateStart = toGeneratedOffset(language, serviceScript, sourceScript, start, isCodeActionsEnabled);
-			const generateEnd = toGeneratedOffset(language, serviceScript, sourceScript, end, isCodeActionsEnabled);
-			if (generateStart !== undefined && generateEnd !== undefined) {
+			const generateRange = toGeneratedRange(language, serviceScript, sourceScript, start, end, isCodeActionsEnabled);
+			if (generateRange !== undefined) {
 				fixes = getCodeFixesAtPosition(
 					targetScript.id,
-					generateStart,
-					generateEnd,
+					generateRange[0],
+					generateRange[1],
 					errorCodes,
 					formatOptions,
 					preferences
@@ -614,23 +614,17 @@ function getEncodedSemanticClassifications(language: Language<string>, getEncode
 			};
 		}
 		if (serviceScript) {
-			let start: number | undefined;
-			let end: number | undefined;
 			const map = language.maps.get(serviceScript.code, targetScript);
-			for (const mapping of map.mappings) {
-				// TODO reuse the logic from language service
-				if (isSemanticTokensEnabled(mapping.data) && mapping.sourceOffsets[0] >= span.start && mapping.sourceOffsets[0] <= span.start + span.length) {
-					start ??= mapping.generatedOffsets[0];
-					end ??= mapping.generatedOffsets[mapping.generatedOffsets.length - 1] + (mapping.generatedLengths ?? mapping.lengths)[mapping.lengths.length - 1];
-					start = Math.min(start, mapping.generatedOffsets[0]);
-					end = Math.max(end, mapping.generatedOffsets[mapping.generatedOffsets.length - 1] + (mapping.generatedLengths ?? mapping.lengths)[mapping.lengths.length - 1]);
-				}
+			const mapped = findOverlapCodeRange(span.start, span.start + span.length, map, isSemanticTokensEnabled);
+			if (!mapped) {
+				return {
+					spans: [],
+					endOfLineState: 0
+				};
 			}
-			start ??= 0;
-			end ??= targetScript.snapshot.getLength();
 			const mappingOffset = getMappingOffset(language, serviceScript);
-			start += mappingOffset;
-			end += mappingOffset;
+			const start = mapped.start + mappingOffset;
+			const end = mapped.end + mappingOffset;
 			const result = getEncodedSemanticClassifications(targetScript.id, { start, length: end - start }, format);
 			const spans: number[] = [];
 			for (let i = 0; i < result.spans.length; i += 3) {
@@ -1086,3 +1080,4 @@ function displayPartsToString(displayParts: ts.SymbolDisplayPart[] | undefined)
 	}
 	return '';
 }
+
diff --git a/packages/typescript/lib/node/transform.ts b/packages/typescript/lib/node/transform.ts
index 32d266e3..c1cde029 100644
--- a/packages/typescript/lib/node/transform.ts
+++ b/packages/typescript/lib/node/transform.ts
@@ -315,6 +315,19 @@ export function* toSourceOffsets(
 	}
 }
 
+export function toGeneratedRange(
+	language: Language,
+	serviceScript: TypeScriptServiceScript,
+	sourceScript: SourceScript<string>,
+	start: number,
+	end: number,
+	filter: (data: CodeInformation) => boolean
+) {
+	for (const result of toGeneratedRanges(language, serviceScript, sourceScript, start, end, filter)) {
+		return result;
+	}
+}
+
 export function* toGeneratedRanges(
 	language: Language,
 	serviceScript: TypeScriptServiceScript,
